<template>
  <div :class="$style.wrapper">
    <base-typography elem-type="h1" type="bold"> </base-typography>
    <div :class="$style.productDetailWrapper">
      <base-spacing metric="rem">
        <base-image
          :imgClass="$style.mainProductImage"
          :class="$style.figureClass"
          soruce="/img/product-images/1.jpg"
          alt="hoodie image"
          lazy-load
        ></base-image>
      </base-spacing>
      <base-spacing metric="rem" :style="{ marginRight: 'auto' }" left="1">
        <base-typography type="bold"> {{ title | capitalize }}</base-typography>
        <base-spacing x="0.3">
          <base-typography type="light" fontSize="0.8rem">
            {{ description }}
          </base-typography>
        </base-spacing>
        <div :class="$style.priceWrapper">
          <base-spacing>
            <base-typography type="bold" color="primary">
              {{ price | currencyFilter }}</base-typography
            >
          </base-spacing>
        </div>
      </base-spacing>

      <base-spacing y="0.1" :class="$style.actionWrapper">
        <base-button @click="handleAddToCart">Add to Cart</base-button>
      </base-spacing>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { createNamespacedHelpers } from "vuex";
import MutationTypes from "@/store/modules/cart/mutation-types";

const { mapMutations } = createNamespacedHelpers("cart");
// components
import BaseSpacing from "@/components/base/BaseSpacing/index.vue";
import BaseTypography from "@/components/base/BaseTypography/index.vue";
import BaseImage from "@/components/base/BaseImage/index.vue";
import BaseButton from "@/components/base/BaseButton/index.vue";

// filters
import currencyFilter from "@/filters/price";

export default Vue.extend({
  name: "RelatedProductListItem",
  components: {
    BaseImage,
    BaseSpacing,
    BaseTypography,
    BaseButton
  },
  filters: {
    currencyFilter
  },
  props: {
    title: {
      type: String,
      required: true
    },
    price: {
      type: Number,
      required: false
    },
    description: {
      type: String,
      required: false
    },
    image: {
      type: String,
      required: false
    },
    id: {
      type: Number,
      required: false
    }
  },
  methods: {
    ...mapMutations({
      addToCart: MutationTypes.ADD_NEW_ITEM_TO_CART
    }),
    handleAddToCart: function() {
      this.addToCart({ id: this.id, quantity: 1 });
    }
  }
});
</script>

<style module lang="scss">
.wrapper {
  composes: display--flex;
  composes: align-items--center;
  composes: justify-content--center;
  margin: 1rem 0;
}

.figureClass {
  max-width: 400px;
}
.actionWrapper {
  composes: display--flex;
  composes: align-items--center;
}
.mainProductImage {
  width: 100px;
  composes: border-radius--default;
}

.productDetailWrapper {
  composes: display--flex;
  composes: align-items--center;
  composes: justify-content--space-between;
}

.priceWrapper {
  composes: display--flex;
}

@media screen and (max-width: $device-size--mobile-large) {
  .productDetailWrapper {
    flex-direction: column;
    img {
      width: 100%;
    }
  }
}
</style>
